// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from naoqi_bridge_msgs:msg/HeadTouch.idl
// generated code does not contain a copyright notice

#include "naoqi_bridge_msgs/msg/detail/head_touch__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_naoqi_bridge_msgs
const rosidl_type_hash_t *
naoqi_bridge_msgs__msg__HeadTouch__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x03, 0x97, 0x4d, 0x3a, 0xab, 0xda, 0x4c, 0x93,
      0x45, 0x94, 0x46, 0x06, 0xf8, 0x40, 0x51, 0x58,
      0x87, 0xe3, 0xb1, 0xf6, 0x8d, 0x08, 0x38, 0x1c,
      0xe5, 0xa1, 0x39, 0x3f, 0x3b, 0xcc, 0x1a, 0x2e,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char naoqi_bridge_msgs__msg__HeadTouch__TYPE_NAME[] = "naoqi_bridge_msgs/msg/HeadTouch";

// Define type names, field names, and default values
static char naoqi_bridge_msgs__msg__HeadTouch__FIELD_NAME__button[] = "button";
static char naoqi_bridge_msgs__msg__HeadTouch__FIELD_NAME__state[] = "state";

static rosidl_runtime_c__type_description__Field naoqi_bridge_msgs__msg__HeadTouch__FIELDS[] = {
  {
    {naoqi_bridge_msgs__msg__HeadTouch__FIELD_NAME__button, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {naoqi_bridge_msgs__msg__HeadTouch__FIELD_NAME__state, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
naoqi_bridge_msgs__msg__HeadTouch__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {naoqi_bridge_msgs__msg__HeadTouch__TYPE_NAME, 31, 31},
      {naoqi_bridge_msgs__msg__HeadTouch__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# A message for Nao's tactile interface (toucht buttons on the head)\n"
  "\n"
  "uint8 button            # which of the three segments is touched\n"
  "uint8 state             # pressed or released, see below\n"
  "\n"
  "uint8 BUTTON_FRONT=1\n"
  "uint8 BUTTON_MIDDLE=2\n"
  "uint8 BUTTON_REAR=3\n"
  "\n"
  "uint8 STATE_RELEASED=0\n"
  "uint8 STATE_PRESSED=1";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
naoqi_bridge_msgs__msg__HeadTouch__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {naoqi_bridge_msgs__msg__HeadTouch__TYPE_NAME, 31, 31},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 302, 302},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
naoqi_bridge_msgs__msg__HeadTouch__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *naoqi_bridge_msgs__msg__HeadTouch__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
